/*
    $Id: userdb.h,v 1.1 2001/02/21 12:42:31 hvr Exp $

    Copyright (C) 2000 Herbert Valerio Riedel <hvr@gnu.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __USERDB_H__
#define __USERDB_H__

#include <glib.h>

/* all users */
const char* userdb_groupname_by_gid (guint32 gid);
const char* userdb_username_by_uid (guint32 uid);

void userdb_register_gid (guint32 gid, const gchar groupname[]);
void userdb_register_uid (guint32 uid, const gchar username[]);

/* primary uid / gid / 2ndary gids */
void userdb_setuser (guint32 uid, guint32 gid,
		     guint ngids, const guint32 gids[]);

guint32 userdb_get_gid ();
guint32 userdb_get_uid ();
gboolean userdb_have_group (guint32 gid);

#endif
