/*
 *   $Id: utils.h,v 1.10 2001/02/28 22:11:22 hvr Exp $
 *
 *   This file is part of OpenFTPD
 *
 *   Copyright (C) 1996-2000  Crescent
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __UTIL_H__
#define __UTIL_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>

/* paths */
void mk_filename (gchar *buf, const gchar filename[], 
		  const gchar defaultname[]);

/* strings */
gint strip_crlf (gchar *buffer);
gchar skipspace (gchar **str);
gchar skipnspace (gchar **str);
gchar skiptocolon (gchar **str);
gchar skipspctocolon (gchar **str);

void sprint_difftime (gchar *str, gint len, gdouble diff);

/* IO */
int   readline(char* line, int linelen, FILE* file);
int   read_to(int fd, char* buf, int buflen, int timeout);
char *fgets_to(char* buf, int buflen, FILE* stream, int timeout);
int   accept_to(int s, struct sockaddr *addr, int *addrlen, int timeout);
int   connect_to(int s, struct sockaddr *addr, int addrlen, int timeout);

/* bitset */
gboolean flag_get (guint32 flags, guint n);
void flag_set (guint32 *flags, guint n, gboolean value);

#endif /* __UTIL_H__ */

/* EOF */
