/*   registry.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996-1999 by Crescent
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*** Variables ***/
extern char*           registry;
extern int             registry_entries;
extern int             registry_maxentries;
extern char**          registry_keys;
extern int             registry_len;
extern int             registry_size;
extern int             registry_dirty;
extern struct config_s config_vars[];

/*** Functions ***/
char** reg_find(char* key);
int    reg_delete(char* key);
char** reg_insert(char* key);
char*  reg_get(char* key);
int    reg_getb(char* key, int defval);
int    reg_geti(char* key, int defval);
gint32  reg_geti32(char* key, gint32 defval);
gint64  reg_geti64(char* key, gint64 defval);
long   reg_getl(char* key, long defval);
void   reg_updatekeys(char* from, int n);
int    reg_put(char* key, char* value);
int    load_registry(char* filename, int reset);
int    save_registry(char* filename);
int    load_config(char* filename, int reconfig, int reset);
void   print_configuration(FILE* out);
int    f4adp_reg_get(struct child_s* c, char** p, int n);
int    f4adp_reg_keys(struct child_s* c, char** p, int n);
int    f4adp_reg_ls(struct child_s* c, char** p, int n);
int    f4adp_reg_rm(struct child_s* c, char** p, int n);
int    f4adp_reg_set(struct child_s* c, char** p, int n);

/* EOF */
