extern int section_stat_dirty;

int load_global_section_config(void);
int load_config_for_single_section(struct section_s*);
int alloc_section(void);
int alloc_config_key(struct section_s*);
int parse_section_config_line(char*);
int parse_config_for_section_line(char*, struct section_s*);
void sort_sections(void);

int get_key_type(struct dircfg_s*);
int get_bool_key(struct dircfg_s*, char*);
int get_char_key(struct dircfg_s*, char*);
int get_int_key(struct dircfg_s*, char*); 
struct section_s* get_section_by_path(char *);
struct section_s* get_section_by_name(char *);
struct section_s* get_section_by_id(int);
int get_section_name(struct child_s*, char**, int);
int get_section_id(struct child_s*, char**, int);
int get_section_credits(struct child_s* c, char**p, int n);
int get_value_by_dir(struct child_s* c, char** p, int n);
int search_key(char *key, struct section_s *s, struct dircfg_s** l); 
struct sstat_s* get_stat_by_uid(struct section_s *s, gint32 uid);
int get_key_value_by_section( struct section_s* s, char *key, char *str, size_t str_len, int *v);

int init_stat_file(struct section_s *s);
int load_stat_file(struct section_s* s);
int save_stat_file(struct section_s *s);
int save_section_stat();
int write_global_stat_file();
int write_section_stat_files();
int load_stat_file_v3012(struct section_s *s);
int f4adp_section_change(struct child_s* c, char** p, int n);
int f4adp_section_reset(struct child_s* c, char** p, int n);
int f4adp_sec_list(struct child_s* c, char** p, int n); /* site sec list */
int f4adp_sec_set(struct child_s* c, char** p, int n); /* site sec set */
int f4adp_get_section_config(struct child_s* c, char** p, int n);
