/* ---------------------------------------------------------------------------
 *
 *   This file is part of OpenFTPD (based on FTP4ALL)
 *   (C) 1996-2000 by Crescent, (C) 2000 by the OpenFTPD Team
 *
 * ---------------------------------------------------------------------------
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 * ---------------------------------------------------------------------------
 *   HEADER: common.h
 * ---------------------------------------------------------------------------
 */

#ifndef __COMMON_H__
#define __COMMON_H__

#include "commondef.h"

/* for send_reply... () functions */
#include "control.h"

/* int send_reply(int rno, char* reply); */
/* int send_error(int rno, char* cmd, int errn); */
/* int send_reply_exp(int rno, char* reply, int expand); */

char class_char(void);
int read_ftp_command(char* buffer, int bufferlen, char** param, int max, int* n);
int parse_command(char* p, char** param, int max, int* n);

int send_message(int rno, int finish, char* buffer, const char *str);
int send_message_exp(int rno, int finish, char* buffer, const char* str, int expand);

int run_program(char* prog, char** param, int n, int rno, int finish, const char* cd,
		int* exitcode, char* buffer, int bufsize, char *relativedir);
int run_prog_xt(char* prog, char **param, int* exitcode, char* returner, 
  char *relativedir);
int cat_help(char *helpstr, int n);
int get_time(time_t tim);
int send_ftpd_reply();
gint64 limit_ok(unsigned long size, const char *dir);
void update_user_activity(int hidden, int activity, float speed, const char *str);
void convert_filename(char* filename, int mode);
void set_enviroments(char *str, int str_size, const char *relativedir);

#endif /* __COMMON_H__ */

/* EOF */
