#!/usr/bin/perl

use strict;

my $standarddir;

if (exists $ENV{'F4A_STD'}) {
	$standarddir = $ENV{'F4A_STD'};
}
elsif ( -e "$ENV{'HOME'}/.openftpdrc" ) {
	$standarddir = `cat $ENV{'HOME'}/.openftpdrc`;
	$standarddir =~ s/\n//;
	$standarddir =~ s/\r//;
}
else {
	print "ERROR: Cant locate your standarddir either in Environment F4A_STD or in $ENV{'HOME'}/.openftpdrc\n";
	exit 1;
}

# change these vars to fit your needs

# where to store the database
my $database = $standarddir."/var/locatedb.txt";

my ($section, $dummy, @result);

if (!exists $ARGV[0]) {
	print "ERROR: No search-string provided !\n";
	exit(-1);
}
if (exists $ARGV[1]) {
	$section=$ARGV[1];
}
else {
	$section=".*";
}

$ARGV[0]=~s/\./\\\./;
$ARGV[0]=~s/\*/\.\*/;
$ARGV[0]=~s/\?/\./;

open(LOCATE,"< $database") or die "ERROR: run site updatedb";
while($dummy=<LOCATE>) {
	if($dummy=~/^$section/i) {
		if($dummy=~/$ARGV[0]/i) {
			chomp($dummy);
			push @result, $dummy;
		}
	}
}
close(LOCATE);
if (@result) {
	foreach $dummy (@result) {
		print "$dummy\n";
	}
}
else {
	print "Nothing found...\n";
}
