package imdb;

use LWP::Simple;
use Exporter;
use strict;

use vars qw(@ISA @EXPORT);


@ISA = qw(Exporter);

@EXPORT = qw(
	get_imdb_url
	parse_imdb
);

# get the imdb url from a text file
sub get_imdb_url {
    my $filename = shift;
    my $url = "--";
    if ( open(NFO, "< $filename") ) {
	my @content = <NFO>;
	my $content = join ('\n', @content);
	if ($content =~ /(http\:\/\/(us|uk|www|german).imdb.com\/(Title|Plot)\?\d+)/s ) {
	    $url = $1;
            if ($3 eq "Plot") {
               $url =~ s/Plot/Title/;
            }
	}
	close (NFO);
    }
    return $url;
}

sub parse_imdb {
	my $url = shift;    
	my (%imdb, $content);
	unless (defined ($content = get ($url))) {
		return;
	} 
	$content = join " ", split /\n/, $content;
#print "*** $content ***\n";

	if ($content =~ /<TITLE>(.+)<\/TITLE>/i) {
		$imdb{'title'} = $1;
	}    
	else {
		$imdb{'title'} = "???";
	}

	if ($content =~ /Genre:<\/b> <a href="\S+">(\S+)<\/a> /i) {
		$imdb{'genre'} = $1;
	}    
	else {
		$imdb{'genre'} = "???";
	}

	if ($content =~ /(Werbezeile|Tagline):<\/b> (.+) <a href="\/Taglines/i) {
		$imdb{'tagline'} = $2;
	}
	else {
		$imdb{'tagline'} = "???";
	}
	#if ($content =~ /<b>(\d\.\d)\/10<\/b> \((\S+) votes\)<\/b>/i) {
	if ($content =~ /<b>(\d\.\d)\/10<\/b> \((\S+) votes\) <a href="\/Ratings/i) {
		$imdb{'rating'} = $1;
		$imdb{'votes'} = $2;
	}
	else {
		$imdb{'rating'} = "?";
		if ($content =~ /awaiting 5 votes/i) {
			$imdb{'votes'} = "awaiting 5";
		}
		else {
			$imdb{'votes'} = "?";
		}
	}

	if ($content =~ /(Plot (Outline|Summary)|Kurzbeschreibung|Inhaltsangabe):<\/b> (.+) <a href="\/Plot/i) {
		$imdb{'plot'} = $3;
	}
	else {
		$imdb{'plot'} = "???";
	}

	return %imdb;
}
