# $Id: fstat.pl,v 1.5.2.1 2001/07/14 12:17:07 prime Exp $
#
use FindBin;
use lib "$FindBin::Bin/../lib";
use perms;

my $site_fstat = sub {
	my $arg = shift;
	my $result;

	$arg = "." if (!$arg);
	my @stat = FTP::vfs_stat ($arg);
	if (!@stat) {
		return (250, "vfs_stat() failed: " . 
		        FTP::vfs_strerror ($FTP::vfs_errno));
	}

	my ($type, $uid, $gid, $mode, $cdpathflag, $crtime, $chtime, $actime,
	    $size, $crc32, $dlc) = @stat;

	my $form = "";

	my $grp = FTP::userdb_groupname_by_gid ($gid);
	$grp = $gid if (!$grp);
	my $usr = FTP::userdb_username_by_uid ($uid);
	$usr = $uid if (!$usr);
	my @mode_str = mode_str_fstat ($type, $mode);

	if ($type == 1) { # regular file
	$form = <<'END';

!G-------------------------------------------------------------------------------!0
!7!HFILE PERMISSION INFORMATION                                                    !0
!G-------------------------------------------------------------------------------!0
!hOBJECT: !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!hCRC32 : !H@<<<<<<<<<!0
!hSIZE  : !H@<<<<<<<<<<<<<<<<<<<<<<<<!0
!G-------------------------------------------------------------------------------!0
!hHEX PERMISSIONS   : !H@<<<<<<<<<!0
!hOWNER [!H@<<<<<<<<!h] : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!hGROUP [!H@<<<<<<<<!h] : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!hOTHERS            : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!G_  _____!0
!G       /!g/ !G:: !hUse SITE CHMOD and SITE CHOWN to change permissions!G::!0
!G      /!g/_______________________________________________________________________!0

END
      $result = swrite ($form, 
			sprintf("%s  !h(PATH: !H%s!h)", $arg, FTP::vfs_getcwd ()),
			sprintf("0x%8.8x", $crc32), $size,
			sprintf("0x%8.8x", $mode),
			$usr, $mode_str[0],
			$grp, $mode_str[1],
			$mode_str[2]);
    }
  else
    { # assume directory
      $form = <<'END';

!G-------------------------------------------------------------------------------!0
!7!HDIRECTORY PERMISSION INFORMATION                                               !0
!G-------------------------------------------------------------------------------!0
!hOBJECT: !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!G-------------------------------------------------------------------------------!0
!hHEX PERMISSIONS   : !H@<<<<<<<<<!0
!hDIRECTORY FLAGS   : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!hOWNER [!H@<<<<<<<<!h] : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!hGROUP [!H@<<<<<<<<!h] : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!hOTHERS            : !H@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<!0
!G_  _____!0
!G       /!g/ !G:: !hUse SITE CHMOD and SITE CHOWN to change permissions!G::!0
!G      /!g/_______________________________________________________________________!0

END
      $result = swrite ($form,
			sprintf("%s  !h(PATH: !H%s!h)", $arg, FTP::vfs_getcwd ()),
			sprintf("0x%8.8x", $mode),
			$mode_str[3],
			$usr, $mode_str[0],
			$grp, $mode_str[1],
			$mode_str[2]);
    }


  return (250, $result);
};

&FTP::bind_site_cmd ("fstat", $site_fstat);
&FTP::bind_site_cmd ("mod", $site_fstat); # backward compat
