# $Id: oneliner.pl,v 1.5.2.4 2001/10/20 16:16:34 pedro Exp $
use lib "$FindBin::Bin/../lib";
use utils;

# config
my $oneliner_lines = 10;
my $oneliner_file =  $FTP::cfg_var_path . "/onel";
my $oneliner_maxlen = 58;

my $oneliner_header = &open_format($FTP::cfg_msg_path."/onel_top");

my $oneliner_footer = &open_format($FTP::cfg_msg_path."/onel_tail");

# code

sub oneliner {
	my $body = "";
	local *ONELFILE;
	my @oneliner = ();

	if (open (ONELFILE, "< $oneliner_file")) {
		while (<ONELFILE>) {
			chomp($_);
			if ($_) {
				push(@oneliner, $_);
				shift(@oneliner) if ($#oneliner >= $oneliner_lines);
      			}
    		}
		close(ONELFILE);
	} 
	else {
		return (200, "No oneliner added yet.");
	}

	my $i = 1;
	foreach my $line (@oneliner) {
		my ($timestamp, $username, $message) = split(/\s+/, $line, 3);
		$body .= sprintf ($i % 2 ? "!H%-10.10s!G|!H%-9.9s!G|!H%-58.58s!0\n" :
		                  "!h%-10.10s!G|!h%-9.9s!G|!h%-58.58s!0\n", 
		                  $timestamp, $username . '.' x 9, $message . '.' x 58);
		$i++;
	}

	return $oneliner_header . $body . $oneliner_footer;
}

# backward compat
sub oneliner_pl {
  oneliner (@_);
}


sub oneliner_timetostring {
	my ($day_of_month, $month, $year) = (localtime)[3..5];
	my $timestring = sprintf("%04d-%02d-%02d",  $year+1900, 
	                         $month+1, $day_of_month);
	return $timestring;
}


my $_site_onel = sub {
	my $line = shift;
	chomp $line;

	if (!$line) {
		return (200, oneliner ());
	}

	if (length($line) > $oneliner_maxlen) {
		return (200, "Line was not added. (Keep it below $oneliner_maxlen chars!)");
	}

	# mask !
	$line =~ s/!/!!/;

	local *ONELFILE;

	if (open(ONELFILE, ">> $oneliner_file")) {
		printf (ONELFILE "%s %s %s\n", oneliner_timetostring(), 
		        $FTP::var_user, $line);
		close(ONELFILE);
		return (200, "Your words of wisdom have been added.");
	}
	return (200, "Some strange error occured... could not add your lines of wisdom");
};

# bind command
FTP::bind_site_cmd ("onel", $_site_onel);
FTP::bind_site_cmd ("oneliner", $_site_onel);

# EOF